<template>
  <div class="dashboard">
    <h2 class="text-grey">Dashboard</h2>

    <v-container class="my-5">
      <v-layout row justify-start class="mb-3">
        <v-btn small flat color="bg-grey" @click="sortBy('title')">
          <v-icon small left icon="mdi-clipboard-check-outline"></v-icon>
          <span class="caption text-lowercase">By project name</span>
          <v-tooltip activator="parent" location="top">
            <span>Sort by project name</span>
          </v-tooltip>
        </v-btn>

        <v-btn small flat color="bg-grey" @click="sortBy('person')">
          <v-icon small left icon="mdi-account"></v-icon>
          <span class="caption text-lowercase">By Person</span>
          <v-tooltip activator="parent" location="top">
            <span>Sort by project author</span>
          </v-tooltip>
        </v-btn>
      </v-layout>

      <v-card flat v-for="project in projects" :key="project.title">
        <v-layout row wrap :class="`pa-3 project ${project.status}`">
          <v-row>
            <v-col xs12 sm4 md6>
              <div class="caption text-grey">Project title</div>
              <div>{{ project.title }}</div>
            </v-col>
            <v-col xs6 sm4 md2>
              <div class="caption text-grey">Person</div>
              <div>{{ project.person }}</div>
            </v-col>
            <v-col xs6 sm4 md2>
              <div class="caption text-grey">Due by</div>
              <div>{{ project.due }}</div>
            </v-col>
            <v-col xs2 sm4 md2>
              <div class="right">
                <v-chip
                  small
                  :class="`${project.status} white--text my-2 caption`"
                  >{{ project.status }}</v-chip
                >
              </div>
            </v-col>
          </v-row>
        </v-layout>
        <v-divider></v-divider>
      </v-card>
    </v-container>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from "vue";

const db_URL = "http://192.168.178.3:3000/todo_items";

const projects = ref([]);

function sortBy(prop : string) {
  projects.value = projects.value.sort((a, b) => (a[prop] < b[prop] ? -1 : 1));
}

// ---------- loading from db --------

async function sloadFromDB(url : string) {
    await fetch(url)
    .then(response => response.json())
    .then(data => ( projects.value = data));
}

onMounted(() => {
  console.log(`the component is now mounted.`);
  //let r = sloadFromDB(db_URL);
 console.log(sloadFromDB(db_URL));
  
});


// -----------------------
</script>

<style scoped>
.project.complete {
  border-left: 4px solid #3cd1c2;
}
.project.ongoing {
  border-left: 4px solid orange;
}
.project.overdue {
  border-left: 4px solid tomato;
}
.v-chip.complete {
  background: #3cd1c2;
}
.v-chip.ongoing {
  background: #ffaa2c;
}
.v-chip.overdue {
  background: #f83e70;
}
</style>
